



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>iOS中navigationItem的titleView如何居中</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">iOS中navigationItem的titleView如何居中</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 20:38:20 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>开发过程中，发现titleview很难居中，通过各种尝试终于找到了解决方法。</p>
<p>首先清楚你个概念：</p>
<ol><li><p>leftBarButtonItem，导航条中左侧button。</p></li>
<li><p>rightBarButtonItem，导航条中右侧button。</p></li>
<li><p>titleview，不用介绍了吧，就是标题。</p></li></ol>
<h2>问题原因：</h2>
<p>经过尝试，发现titleview的起点位置和尺寸依赖于leftBarButtonItem和rightBarButtonItem的位置。</p>
<h2>解决方案：</h2>
<p>设置titleview之前，先初始化leftBarButtonItem和rightBarButtonItem的位置，然后根据leftBarButtonItem和rightBarButtonItem的位置来使titleview居中。</p>
<div>
<pre class="prettyprint linenums">//以下使参考代码。

//必须放在 leftBarButtonItem和rightBarButtonItem初始化之后调用

- (void)setDisplayCustomTitleText:(NSString*)text

{

    // Init views with rects with height and y pos

    UIView *titleView = [[UIView alloc] initWithFrame:CGRectMake(, , , )];

    // Use autoresizing to restrict the bounds to the area that the titleview allows

    titleView.autoresizingMask = UIViewAutoresizingFlexibleWidth | UIViewAutoresizingFlexibleLeftMargin | UIViewAutoresizingFlexibleRightMargin;

    titleView.autoresizesSubviews = YES;

    titleView.backgroundColor = [UIColorclearColor];

    UILabel *titleLabel = [[UILabel alloc] initWithFrame:CGRectMake(, , , )];

    titleLabel.tag = kUIVIEWCONTROLLER_LABEL_TAG;

    titleLabel.backgroundColor = [UIColor clearColor];

    titleLabel.font = [UIFont fontWithName:@"Helvetica-Bold" size:];

    titleLabel.textAlignment = UITextAlignmentCenter;

    titleLabel.autoresizingMask = UIViewAutoresizingFlexibleWidth | UIViewAutoresizingFlexibleHeight;

    titleLabel.textColor = TC_CNavigationTitleColor;

    titleLabel.lineBreakMode = UILineBreakModeClip;

    titleLabel.textAlignment = UITextAlignmentCenter;

    titleLabel.autoresizingMask = titleView.autoresizingMask;

    CGRect leftViewbounds = self.navigationItem.leftBarButtonItem.customView.bounds;

    CGRect rightViewbounds = self.navigationItem.rightBarButtonItem.customView.bounds;

    CGRect frame;

    CGFloat maxWidth = leftViewbounds.size.width &gt; rightViewbounds.size.width ? leftViewbounds.size.width : rightViewbounds.size.width;

    maxWidth += ;//leftview 左右都有间隙，左边是5像素，右边是8像素，加2个像素的阀值 5 ＋ 8 ＋ 2

    frame = titleLabel.frame;

    frame.size.width =  - maxWidth * ;

    titleLabel.frame = frame;

    frame = titleView.frame;

    frame.size.width =  - maxWidth * ;

    titleView.frame = frame;

    // Set the text

    titleLabel.text = text;

        // Add as the nav bar's titleview

    [titleView addSubview:titleLabel];

    self.navigationItem.titleView = titleView;

}</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/wq1vyp6q.html">Jquery操作cookie，实现简单的记住用户名的操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyrpex8.html">Qt 获取本机ip地址 　【转自 CSDN jpchen609</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwp2yy8.html">BZOJ 1925&lbrack;Sdoi2010&rsqb;地精部落 题解</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql3p20q.html">对比学习UIKit和AppKit -- ViewController</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qn35mg9.html">android&period;os&period;BadParcelableException&colon; ClassNotFoundException when unmarshalling&colon;解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/m961ewy8.html">转-CSS3 圆角（border-radius）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd154dq.html">HDOJ-三部曲-多重背包-1014-Cash Machine</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok5kxl9.html">MySQL执行SHOW STATUS查询服务器状态状态之Handler&lowbar;read&lowbar;&ast; 详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xdr2v8.html">【C&num;学习笔记】自我复制</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvnoojq.html">KMP学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvp1rxq.html">399&period; Evaluate Division</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpdwz59.html">PE文件详解（六）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyk14e9.html">51 nod 1439 互质对&lpar;Moblus容斥&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv16ozjq.html">JS实现图片base64转blob对象，压缩图片，预览图片，图片旋转到正确角度</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jyxyeq.html">面试题&lowbar;lambda函数调用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5gedrq.html">Idea搭建SpringMVC框架（初次接触）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1x6g09.html">python自动发送测试报告（五）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zynjz39.html">QTCreator 调试：unknown debugger type &amp;quot&semi;No engine&amp;quot&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jmm3kw9.html">如何解析本地和线上XML文件获取相应的内容</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwlrryy9.html">在 WampServer 上手工安装 PHP 的多个版本</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qlm0y719.html">百度分享 ajax 或分页后显示不出问题解决方案</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwdy6xr8.html">javascript常用代码大全</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pj516z9.html">Android Toast和Notification</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1leee9.html">ASP&period;NET MVC 过滤器Filter</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1g1rj9.html">TWIG整合</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxnmn308.html">WPF学习笔记-使用自定义资源字典（style）文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ok0kxx9.html">thinkphp3&period;2&period;2前后台公用类架构问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1lygk9.html">JSP - request - 1</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1z6rr59.html">&lbrack;BZOJ 3172&rsqb; &lbrack;Tjoi2013&rsqb; 单词 【AC自动机】</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1lm1e9.html">Highways poj 2485</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
